package com.sztzjy.resource_center.controller.new_module.admin;

import cn.hutool.core.util.IdUtil;
import com.github.pagehelper.PageInfo;
import com.google.common.reflect.TypeToken;
import com.nimbusds.jose.shaded.gson.Gson;
import com.nimbusds.jose.shaded.gson.JsonSyntaxException;
import com.sztzjy.resource_center.annotation.AnonymousAccess;
import com.sztzjy.resource_center.entity.admin.*;
import com.sztzjy.resource_center.mapper.admin.AdminCaseMapper;
import com.sztzjy.resource_center.mapper.admin.AdminDataLabelMapper;
import com.sztzjy.resource_center.mapper.admin.AdminFileMapper;
import com.sztzjy.resource_center.util.PageUtil;
import com.sztzjy.resource_center.util.ResultEntity;
import com.sztzjy.resource_center.util.file.IFileUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpStatus;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

/**
 * @Author xcj
 * @Date 2024/7/11
 */
@RestController
@Api(tags = "管理员案例集锦页面")
@RequestMapping("api/admin/case")
public class AdminCaseController {
    @Autowired
    private AdminCaseMapper adminCaseMapper;
    @Autowired
    private AdminDataLabelMapper adminDataLabelMapper;
    @Autowired
    private AdminFileMapper adminFileMapper;
    @Autowired
    private IFileUtil fileUtil;
    @Value("${file.path}")
    private String filePath;


//   /* @PostMapping("add")
//    @ApiOperation("新增")  //todo 案例目录和案例正文通过前端传路径过来 ，这里只存url
//    @Transactional*/
//    ResultEntity<String> add(@ModelAttribute AdminCaseDto adminCaseDto,
//                             @RequestParam String adminCaseDtoJson,
//                             @RequestParam MultipartFile pictureFile,
//                             @RequestParam List<MultipartFile> dataFile) {
//        if (StringUtils.isBlank(adminCaseDto.getName())) {
//            return new ResultEntity<>(HttpStatus.OK, "请输入名称！");
//        }
//        if (adminCaseDto.getAdminLabelList() == null || adminCaseDto.getAdminLabelList().isEmpty()) {
//            return new ResultEntity<>(HttpStatus.OK, "至少选择一个标签！");
//        }
//        List<AdminLabel> adminLabelList = adminCaseDto.getAdminLabelList();
//        for (AdminLabel adminLabel : adminLabelList) {
//            if (StringUtils.isBlank(adminLabel.getLabelId()) || StringUtils.isBlank(adminLabel.getName()) || StringUtils.isBlank(adminLabel.getType())) {
//                return new ResultEntity<>(HttpStatus.OK, "标签数据不完整！");
//            }
//        }
//        if (StringUtils.isBlank(adminCaseDto.getCaseContent()) && adminCaseDto.getCaseContentFile() == null) {
//            return new ResultEntity<>(HttpStatus.OK, "请输入内容或者上传文件！");
//        }
//
//        //开始新增
//        AdminCaseWithBLOBs adminCase = new AdminCaseWithBLOBs();
//        String caseId = IdUtil.randomUUID();
//        adminCase.setId(caseId);
//        adminCase.setName(adminCaseDto.getName());
//        adminCase.setStatus(0); //新增默认下架，发布后上架
//        adminCase.setSource(adminCaseDto.getSource());
//        adminCase.setCreateTime(new Date());
//
//        if (adminCaseDto.getPictureFile() != null) {
//            String pictureUrl = fileUtil.upload(adminCaseDto.getPictureFile());
//            adminCase.setPictureUrl(pictureUrl);
//        }
//
//        //设置内容
//        if (adminCaseDto.getCaseContentFile() != null) {
//            String contentUrl = fileUtil.upload(adminCaseDto.getCaseContentFile());
//            adminCase.setContent(contentUrl);  //传的文件就存地址
//        }
//        if (StringUtils.isNotBlank(adminCaseDto.getCaseContent())) {
//            adminCase.setContent(adminCaseDto.getCaseContent());
//        }
//
//        //设置目录
//        if (adminCaseDto.getCaseCatalogFile() != null) {
//            String caseCatalogUrl = fileUtil.upload(adminCaseDto.getCaseCatalogFile());
//            adminCase.setCatalog(caseCatalogUrl);  //传的文件就存地址
//        }
//        if (StringUtils.isNotBlank(adminCaseDto.getCaseCatalog())) {
//            adminCase.setCatalog(adminCaseDto.getCaseCatalog());
//        }
//
//        //设置数据文件
//        if (adminCaseDto.getDataFile() != null && !adminCaseDto.getDataFile().isEmpty()) {
//            List<MultipartFile> dataFileList = adminCaseDto.getDataFile();
//            List<AdminFile> list = new ArrayList<>();
//            for (MultipartFile file : dataFileList) {
//                AdminFile adminFile = new AdminFile();
//                adminFile.setFileId(IdUtil.randomUUID());
//                String pictureUrl = fileUtil.upload(file);
//                String name = file.getName();
//                adminFile.setFileUrl(pictureUrl);
//                adminFile.setName(name);
//                adminFile.setSource("案例表");
//                adminFile.setDataCaseId(caseId);
//                list.add(adminFile);
//            }
//            //批量新增数据文件
//            adminFileMapper.insertBatch(list);
//        }
//
//        List<AdminDataLabel> list = new ArrayList<>();
//        for (AdminLabel adminLabel : adminLabelList) {
//            AdminDataLabel label = new AdminDataLabel();
//            label.setId(IdUtil.randomUUID());
//            label.setLabelId(adminLabel.getLabelId());
//            label.setName(adminLabel.getName());
//            label.setDataCaseId(adminCaseDto.getCaseId());
//            list.add(label);
//        }
//        //批量新增标签
//        adminDataLabelMapper.insertBatch(list);
//        //新增案例
//        adminCaseMapper.insert(adminCase);
//        return new ResultEntity<>(HttpStatus.OK, "新增成功！");
//    }

    @PostMapping("add")
    @ApiOperation("新增")  //todo 案例目录和案例正文通过前端传路径过来 ，这里只存url
    @Transactional
    ResultEntity<String> add(@RequestParam String name,
                             @RequestParam String source,
                             @RequestParam MultipartFile pictureFile,
                             @RequestParam String adminLabelJson,
                             @RequestParam(required = false) List<MultipartFile> dataFile) {
        Gson gson = new Gson();
        List<AdminLabel> adminLabelList = null;
        try {
            adminLabelList = gson.fromJson(adminLabelJson, new TypeToken<List<AdminLabel>>() {
            }.getType());
        } catch (JsonSyntaxException e) {
            e.printStackTrace();
            return new ResultEntity<>(HttpStatus.INTERNAL_SERVER_ERROR, "服务器错误，请联系管理员");
        }
        if (StringUtils.isBlank(name)) {
            return new ResultEntity<>(HttpStatus.OK, "请输入名称！");
        }
        if (adminLabelList == null || adminLabelList.isEmpty()) {
            return new ResultEntity<>(HttpStatus.OK, "至少选择一个标签！");
        }
        for (AdminLabel adminLabel : adminLabelList) {
            if (StringUtils.isBlank(adminLabel.getLabelId()) || StringUtils.isBlank(adminLabel.getName()) || StringUtils.isBlank(adminLabel.getType())) {
                return new ResultEntity<>(HttpStatus.OK, "标签数据不完整！");
            }
        }

        AdminCaseWithBLOBs adminCaseWithBLOB = new AdminCaseWithBLOBs();
        String uuid = IdUtil.randomUUID();
        adminCaseWithBLOB.setId(uuid);
        adminCaseWithBLOB.setSource(source);
        adminCaseWithBLOB.setCreateTime(new Date());
        adminCaseWithBLOB.setStatus(0); //新增默认下架，发布后上架
        adminCaseWithBLOB.setName(name);
        //设置图片
        if (pictureFile != null) {
            String pictureUrl = fileUtil.upload(pictureFile);
            adminCaseWithBLOB.setPictureUrl(pictureUrl);
        }

        //设置数据文件
        if (dataFile != null && !dataFile.isEmpty()) {
            List<AdminFile> list = new ArrayList<>();
            for (MultipartFile file : dataFile) {
                AdminFile adminFile = new AdminFile();
                adminFile.setFileId(IdUtil.randomUUID());
                String dataUrl = fileUtil.upload(file);
                String fullFileName = file.getOriginalFilename();
                adminFile.setFileUrl(dataUrl);
                adminFile.setName(fullFileName);
                adminFile.setSource("数据表");
                adminFile.setDataCaseId(uuid);
                list.add(adminFile);
            }
            //批量新增数据文件
            adminFileMapper.insertBatch(list);
        }

        //批量新增标签
        List<AdminDataLabel> list = new ArrayList<>();
        for (AdminLabel adminLabel : adminLabelList) {
            AdminDataLabel label = new AdminDataLabel();
            label.setId(IdUtil.randomUUID());
            label.setLabelId(adminLabel.getLabelId());
            label.setName(adminLabel.getName());
            label.setDataCaseId(uuid);
            label.setType(adminLabel.getType());
            list.add(label);
        }
        try {
            adminDataLabelMapper.insertBatch(list);
            adminCaseMapper.insert(adminCaseWithBLOB);
        } catch (Exception e) {
            e.printStackTrace();
            return new ResultEntity<>(HttpStatus.INTERNAL_SERVER_ERROR, "新增失败！请联系管理员");
        }
        return new ResultEntity<>(HttpStatus.OK, "新增成功！");
    }


    @PostMapping("get")
    @ApiOperation("展示")
    @AnonymousAccess
    private ResultEntity<PageInfo<AdminCaseReturnDto>> get(@RequestParam Integer index,
                                                           @RequestParam Integer size,
                                                           @RequestParam(required = false) String keyWord,
                                                           @ApiParam("精品案例不传，院校案例传'院校案例'") @RequestParam(required = false) String source,
                                                           @RequestParam(required = false) String labelName) {
        List<String> list = new ArrayList<>();
        if (StringUtils.isNotBlank(labelName)) {
            String[] split = labelName.split(",");
            list = Arrays.asList(split);
        }
        List<AdminCaseReturnDto> adminCaseReturnDtos = adminCaseMapper.selectByConditions(keyWord, source, list);
        PageInfo pageInfo = PageUtil.pageHelper(adminCaseReturnDtos, index, size);
        return new ResultEntity<>(pageInfo);
    }


    @PostMapping("updateAdminCase")
    @ApiOperation("案例编辑/没改的参数别传")
    @Transactional
    ResultEntity<String> updateAdminCase(@RequestParam String caseId,
                                         @RequestParam(required = false) String name,
                                         @RequestParam(required = false) MultipartFile pictureFile,
                                         @RequestParam(required = false) String adminLabelJson) {
        if (StringUtils.isBlank(name)
                && pictureFile == null
                && StringUtils.isBlank(adminLabelJson)) {
            return null;
        }

        Gson gson = new Gson();
        List<AdminLabel> adminLabelList = null;
        try {
            if (StringUtils.isNotBlank(adminLabelJson)) {
                adminLabelList = gson.fromJson(adminLabelJson, new TypeToken<List<AdminLabel>>() {
                }.getType());
            }
        } catch (JsonSyntaxException e) {
            e.printStackTrace();
            return new ResultEntity<>(HttpStatus.INTERNAL_SERVER_ERROR, "服务器错误，请联系管理员");
        }

        AdminCaseWithBLOBs adminCaseWithBLOBs = adminCaseMapper.selectByPrimaryKey(caseId);
        if (pictureFile != null) {
            String fileUrl = fileUtil.upload(pictureFile);
            adminCaseWithBLOBs.setPictureUrl(fileUrl);
        }
        if (StringUtils.isNotBlank(name)) {
            adminCaseWithBLOBs.setName(name);
            adminCaseMapper.updateByPrimaryKeySelective(adminCaseWithBLOBs);
        }
        if (adminLabelList != null && !adminLabelList.isEmpty()) {
            List<AdminDataLabel> list = new ArrayList<>();
            for (AdminLabel adminLabel : adminLabelList) {

                if (StringUtils.isBlank(adminLabel.getLabelId()) || StringUtils.isBlank(adminLabel.getName()) || StringUtils.isBlank(adminLabel.getType())) {
                    return new ResultEntity<>(HttpStatus.OK, "标签数据不完整！");
                } else {
                    AdminDataLabelExample example = new AdminDataLabelExample();
                    example.createCriteria().andDataCaseIdEqualTo(caseId);
                    adminDataLabelMapper.deleteByExample(example);
                    //批量新增标签
                    AdminDataLabel label = new AdminDataLabel();
                    label.setId(IdUtil.randomUUID());
                    label.setLabelId(adminLabel.getLabelId());
                    label.setName(adminLabel.getName());
                    label.setDataCaseId(caseId);
                    label.setType(adminLabel.getType());
                    list.add(label);
                }
            }
            adminDataLabelMapper.insertBatch(list);
        }
        return new ResultEntity<>(HttpStatus.OK, "编辑成功！");
    }


    @PostMapping("updateStatus")
    @ApiOperation("发布或禁用")
    private ResultEntity<String> add(@RequestParam String id,
                                     @ApiParam("传0禁用，传1发布上架") @RequestParam int status) {
        try {
            AdminCaseWithBLOBs adminCaseWithBLOBs = adminCaseMapper.selectByPrimaryKey(id);
            adminCaseWithBLOBs.setStatus(status);
            adminCaseMapper.updateByPrimaryKeyWithBLOBs(adminCaseWithBLOBs);
        } catch (Exception e) {
            e.printStackTrace();
            return new ResultEntity<>(HttpStatus.INTERNAL_SERVER_ERROR, "发生错误，请联系管理员！");
        }
        if (status == 0) {
            return new ResultEntity<>(HttpStatus.OK, "成功禁用！");
        }
        if (status == 1) {
            return new ResultEntity<>(HttpStatus.OK, "成功发布！");
        }
        return null;
    }


    @PostMapping("deleteCase")
    @ApiOperation("删除案例题/管理员使用")
    private ResultEntity<String> deleteCase(@RequestParam String caseId) {
        try {
            //删除案例绑定文件
            AdminFileExample example = new AdminFileExample();
            example.createCriteria().andDataCaseIdEqualTo(caseId);
            adminFileMapper.deleteByExample(example);

            //删除案例绑定标签
            AdminDataLabelExample example1 = new AdminDataLabelExample();
            example1.createCriteria().andDataCaseIdEqualTo(caseId);
            adminDataLabelMapper.deleteByExample(example1);
            adminCaseMapper.deleteByPrimaryKey(caseId);
        } catch (Exception e) {
            e.printStackTrace();
            return new ResultEntity<>(HttpStatus.INTERNAL_SERVER_ERROR, "上传失败，请联系管理员！");
        }
        return new ResultEntity<>(HttpStatus.OK, "删除成功！");
    }

}
