package com.sztzjy.resource_center.controller.new_module.stu;

import cn.hutool.json.ObjectMapper;
import com.fasterxml.jackson.databind.SerializationFeature;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.sztzjy.resource_center.annotation.AnonymousAccess;
import com.sztzjy.resource_center.entity.AdminComponentCode;
import com.sztzjy.resource_center.entity.AdminComponentCodeWithBLOBs;
import com.sztzjy.resource_center.entity.dto.StuCodeDTO;
import com.sztzjy.resource_center.entity.dto.StuComponentCodeDTO;
import com.sztzjy.resource_center.mapper.AdminComponentCodeMapper;
import com.sztzjy.resource_center.util.ConvertUtil;
import com.sztzjy.resource_center.util.ResultEntity;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.codehaus.jackson.JsonFactory;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.List;


/**
 * @author tz
 * @date 2024/7/26 10:13
 */
@RestController
@Api(tags = "学生端组件代码模块")
@RequestMapping("api/stu/componentCode")
public class StuComponentCodeController {
    @Resource
    AdminComponentCodeMapper adminComponentCodeMapper;
    @Resource
    ConvertUtil convertUtil;

    @PostMapping("/getComponentCode")
    @ApiOperation("组件代码展示")
    @AnonymousAccess
    public ResultEntity getComponentCode(){
        //查询所有一级标签
        List<String> byCourseName = adminComponentCodeMapper.getByCourseName();

        //查询出所有数据
        List<AdminComponentCodeWithBLOBs> adminComponentCodes = adminComponentCodeMapper.selectByExampleWithBLOBs(null);


        List<StuComponentCodeDTO> componentCodeDTOS=new ArrayList<>();


        for (String courseName : byCourseName) {
            StuComponentCodeDTO componentCodeDTO=new StuComponentCodeDTO();
            componentCodeDTO.setCourseName(courseName);

            componentCodeDTOS.add(componentCodeDTO);
        }

        //遍历
        for (StuComponentCodeDTO componentCodeDTO : componentCodeDTOS) {

            List<StuCodeDTO> stuCodeDTOS=new ArrayList<>();

            for (AdminComponentCodeWithBLOBs adminComponentCode : adminComponentCodes) {

                if (adminComponentCode.getCourseName().equals(componentCodeDTO.getCourseName())) {
                    StuCodeDTO stuCodeDTO = convertUtil.entityToDTO(adminComponentCode, StuCodeDTO.class);

                    stuCodeDTOS.add(stuCodeDTO);
                }
            }
            componentCodeDTO.setChildren(stuCodeDTOS);
        }
        return new ResultEntity(HttpStatus.OK,"成功",componentCodeDTOS);
    }
}
