package com.sztzjy.resource_center.mapper;

import com.sztzjy.resource_center.entity.SysThreeCatalog;
import com.sztzjy.resource_center.entity.SysThreeCatalogExample;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;
import java.util.Map;

@Mapper
public interface SysThreeCatalogMapper {
    long countByExample(SysThreeCatalogExample example);

    int deleteByExample(SysThreeCatalogExample example);

    int deleteByPrimaryKey(String threeId);

    int insert(SysThreeCatalog record);

    int insertSelective(SysThreeCatalog record);

    List<SysThreeCatalog> selectByExample(SysThreeCatalogExample example);

    SysThreeCatalog selectByPrimaryKey(String threeId);

    int updateByExampleSelective(@Param("record") SysThreeCatalog record, @Param("example") SysThreeCatalogExample example);

    int updateByExample(@Param("record") SysThreeCatalog record, @Param("example") SysThreeCatalogExample example);

    int updateByPrimaryKeySelective(SysThreeCatalog record);

    int updateByPrimaryKey(SysThreeCatalog record);

    @Select("select three_id,three_name from sys_three_catalog where ont_id = #{oneId} and two_id =#{twoId} order by sort ASC")
    List<Map<String, String>> getAllThreeCatalogList(@Param("oneId") String oneId, @Param("twoId") String twoId);

    void updateByBatch(@Param("sysThreeCatalogs") List<SysThreeCatalog> sysThreeCatalogs);

    @Select("select count(*) from sys_three_catalog where ont_id = #{oneId}")
    Integer countByOneId(@Param("oneId") String oneId);

    @Select("SELECT three_name FROM sys_three_catalog s  \n" +
            " join sys_two_catalog st\n" +
            "ON st.two_id = s.two_id \n" +
            "AND s.ont_id = #{oneId}\n" +
            "where s.creator in ('管理员',#{source})")
    List<String> selectNameByCourseID(@Param("oneId") String oneId,
                                      @Param("source") String source);

    @Select("select three_id from sys_three_catalog where three_name =#{threeName} and two_name ={twoName}")
    String getIdByName(@Param("threeName") String threeName,
                       @Param("twoName") String twoName);
}